﻿[System.Reflection.Assembly]::LoadWithPartialName('Microsoft.SqlServer.SMO')  | out-null #A


function Get-SQLdatabase{

    [CmdletBinding()]
    Param(
        [Parameter(
            Mandatory=$true,
            Position=1,
            HelpMessage="Please provide the SQL Server name"
        )]
        [string]$SQLserver
    )

    DynamicParam {
 
            # Set the dynamic parameters' name
            $ParameterName = 'Database'
 
            # Create the dictionary
            $RuntimeParameterDictionary = New-Object System.Management.Automation.RuntimeDefinedParameterDictionary
 
            # Create the collection of attributes
            $AttributeCollection = New-Object System.Collections.ObjectModel.Collection[System.Attribute]
 
            # Create and set the parameters attributes
            $ParameterAttribute = New-Object System.Management.Automation.ParameterAttribute
            $ParameterAttribute.Mandatory = $False
            $ParameterAttribute.Position = 2
 
            # Add the attributes to the attributes collection
            $AttributeCollection.Add($ParameterAttribute)
 
            # Generate and set the ValidateSet
            $server = new-object ("Microsoft.SqlServer.Management.Smo.Server") $SQLserver
            
            $arrset = $server.databases.name
            $ValidateSetAttribute = New-Object System.Management.Automation.ValidateSetAttribute($arrSet)
 
            # Add the ValidateSet to the attributes collection
            $AttributeCollection.Add($ValidateSetAttribute)
 
            # Create and return the dynamic parameter
            $RuntimeParameter = New-Object System.Management.Automation.RuntimeDefinedParameter( $ParameterName, [string], $AttributeCollection)
            $RuntimeParameterDictionary.Add( $ParameterName, $RuntimeParameter)
            return $RuntimeParameterDictionary
    }
    begin {
            $server = new-object ("Microsoft.SqlServer.Management.Smo.Server") $SQLserver
    }
         
    process {
        #if the database parameter was passed shoiws only the propertis of the database
        #otherwise show the properties of all databases

        if ($psboundparameters.Keys.Contains('database'))  {
           $server.Databases[$psboundparameters.database]
        } else {
           $server.Databases
        }
    }


}
Get-SQLdatabase -SQLserver . -Database AdventureWorks2022
